
// Returns the bloom tile you are currently on
int is_in_range(vec2 texcoord) { 
    vec2 Bounds = vec2(0); // x is lower bound and y is upper
    for(int i = 2; i <= 2+BLOOM_SIZE; i++) {
        Bounds.x = Bounds.y;
        Bounds.y += 1/exp2(i);
        if(all(greaterThan(texcoord, vec2(Bounds.x))) && all(lessThan(texcoord, vec2(Bounds.y)))) {
            return i;
        }
    }
    return 0;
}

int is_in_range(vec2 texcoord, out vec2 Bounds) {
    Bounds = vec2(0); // x is lower bound and y is upper
    for(int i = 2; i <= 2+BLOOM_SIZE; i++) {
        Bounds.x = Bounds.y;
        Bounds.y += 1/exp2(i);
        if(all(greaterThan(texcoord, vec2(Bounds.x))) && all(lessThan(texcoord, vec2(Bounds.y)))) {
            return i;
        }
    }
    return 0;
}

// https://github.com/Experience-Monks/glsl-fast-gaussian-blur
vec3 blur(sampler2D image, vec2 texcoord, vec2 direction, vec2 Bounds) {
    vec3 color = vec3(0.0);
    vec2 off1 = vec2(1.3333333333333333) * direction / resolution;
    color += texture2D(image, texcoord).rgb * 0.29411764705882354;
    if(all(greaterThan(texcoord + off1, vec2(Bounds.x))) && all(lessThan(texcoord + off1, vec2(Bounds.y)))) 
        color += texture2D(image, texcoord + off1).rgb * 0.35294117647058826;
    if(all(greaterThan(texcoord - off1, vec2(Bounds.x))) && all(lessThan(texcoord - off1, vec2(Bounds.y)))) 
        color += texture2D(image, texcoord - off1).rgb * 0.35294117647058826;
    return color; 
}



