#include "/lib/all_the_libs.glsl"
#include "/global/lighting.vsh"

flat varying mat3 TBN;
attribute vec4 at_tangent;

void main() {
	init_generic();
	
	#ifndef DISTANT_HORIZONS
	if(material == 10002) {
		vec3 WorldPos = mat3(gbufferModelViewInverse) * ViewPos;
		WorldPos += cameraPosition;
		
		float Noise = dot(sin(WorldPos*2), sin(vec3(frameTimeCounter*0.69, frameTimeCounter*0.47, frameTimeCounter*0.86)*WAVE_SPEED))*0.1*LightmapCoords.y;
		
		if(fract(WorldPos.y+0.005) > 0.01)
			WorldPos.y += Noise/5-0.05;

		WorldPos -= cameraPosition;
		WorldPos = mat3(gbufferModelView) * WorldPos;
		gl_Position = gl_ProjectionMatrix * vec4(WorldPos, 1);
	}
	#endif

	vec3 binormal = normalize(gbufferModelView[2].xyz);
	vec3 tangent  = normalize(gbufferModelView[0].xyz);
	TBN = mat3(tangent, binormal, Normal);

	#if TAA_MODE >= 2
    gl_Position.xy += jitterOffsets[int(framemod8)] * gl_Position.w/resolution;
    #endif
}
